#include "gb.h"
#include "drawing.h"

void save_pic (void);
void load_pic (void);

void main (void)
{  
  if( _cpu==CGB_TYPE )
  {
    /* set the title palette 1*/
    set_bkg_palette_entry(0,0,RGB(31,31,31));
  	set_bkg_palette_entry(0,1,RGB(0,0,31));
  	set_bkg_palette_entry(0,2,RGB(0,31,0));
    set_bkg_palette_entry(0,3,RGB(31,0,0));
  }

// either uncomment the draw and save or the load.

//  color (BLACK,WHITE,SOLID);
//  line (0,0,159,143);
//  line (159,0,0,143);
//  circle (100,100,50,M_NOFILL); 
//  save_pic();

//  load_pic();
 
  color (BLACK,WHITE,SOLID);
  line (0,100,159,100);

  //loop FOREVER
  while (1==1);
}


void save_pic (void)
{
  
  UBYTE* sp;
  UBYTE e,x,y,c1,c2;
  long pos;

  ENABLE_RAM_MBC1;
  sp = (UBYTE *)0xa000;
  pos = 0;
  c1 = 0;

  for (y=0;y<144;y++)
  for (x=0;x<160;x++)
  {
    c2 = getpix(x,y);
    c1 = (c1*4) + c2;
    if ((x & 3) == 3) // if x is the fourth pixel
    {
      sp[pos] = c1;
      c1 = 0;
      pos++;
    }
  }
     
  DISABLE_RAM_MBC1;
}

void load_pic(void)
{
  UBYTE* sp;
  UBYTE e,x,y,c2,c1,p;
  long pos;

  ENABLE_RAM_MBC1;

  sp = (UBYTE *)0xa000;
  pos = 0;
  c1 = 0;
  c2 = 0;
 
  for (y=0;y<144;y++)
  for (x=0;x<40;x++)
  {
    c1 = sp[pos];
    pos++;      
   
    for (e=0;e<4;e++)
    {
      c2 = c1 % 4;
      
      if (c2 != WHITE)  
      {
        color (c2,WHITE,SOLID);
        plot_point(x*4+3-e,y);
      }
      c1 = c1>>2;
    }
    
  }
     
  DISABLE_RAM_MBC1;
}

